# Vertex data input type
NONE = 0
DIRECT = 1
INDEX8 = 2
INDEX16 = 3

# Vertex attribute array type
VA_PTNMTXIDX = 0
VA_TEX0MTXIDX = 1
VA_TEX1MTXIDX = 2
VA_TEX2MTXIDX = 3
VA_TEX3MTXIDX = 4
VA_TEX4MTXIDX = 5
VA_TEX5MTXIDX = 6
VA_TEX6MTXIDX = 7
VA_TEX7MTXIDX = 8
VA_POS = 9
VA_NRM = 10
VA_CLR0 = 11
VA_CLR1 = 12
VA_TEX0 = 13
VA_TEX1 = 14
VA_TEX2 = 15
VA_TEX3 = 16
VA_TEX4 = 17
VA_TEX5 = 18
VA_TEX6 = 19
VA_TEX7 = 20
POSMTXARRAY = 21
NRMMTXARRAY = 22
TEXMTXARRAY = 23
LIGHTARRAY = 24
VA_NBT = 25
VA_NULL = 0xFF

VA_CLR = [VA_CLR0,VA_CLR1]
VA_TEX = [VA_TEX0,VA_TEX1,VA_TEX2,VA_TEX3,VA_TEX4,VA_TEX5,VA_TEX6,VA_TEX7]

# Vertex attribute component count
POS_XY = 0
POS_XYZ = 1
NRM_XYZ = 0
NRM_NBT = 1
NRM_NBT3 = 2
CLR_RGB = 0
CLR_RGBA = 1
TEX_S = 0
TEX_ST = 1

# Vertex attribute component type
U8 = 0
S8 = 1
U16 = 2
S16 = 3
F32 = 4
RGB565 = 0
RGB8 = 1
RGBX8 = 2
RGBA4 = 3
RGBA6 = 4
RGBA8 = 5

# Primitive type
POINTS = 0xB8
LINES = 0xA8
LINESTRIP = 0xB0
TRIANGLES = 0x90
TRIANGLESTRIP = 0x98
TRIANGLEFAN = 0xA0
QUADS = 0x80

# Color channel
COLOR0 = 0
COLOR1 = 1
ALPHA0 = 2
ALPHA1 = 3
COLOR0A0 = 4
COLOR1A1 = 5
COLOR_ZERO = 6
ALPHA_BUMP = 7
ALPHA_BUMPN = 8
COLOR_NULL = 0xFF

# Color channel source
SRC_REG = 0
SRC_VTX = 1

# Light flag
LIGHT0 = 0x001
LIGHT1 = 0x002
LIGHT2 = 0x004
LIGHT3 = 0x008
LIGHT4 = 0x010
LIGHT5 = 0x020
LIGHT6 = 0x040
LIGHT7 = 0x080
LIGHT_NULL = 0x000

# Diffuse function
DF_NONE = 0
DF_SIGNED = 1
DF_CLAMP = 2

# Attenuation function
AF_SPEC = 0
AF_SPOT = 1
AF_NONE = 2

# Texture matrix index
TEXMTX0 = 30
TEXMTX1 = 33
TEXMTX2 = 36
TEXMTX3 = 39
TEXMTX4 = 42
TEXMTX5 = 45
TEXMTX6 = 48
TEXMTX7 = 51
TEXMTX8 = 54
TEXMTX9 = 57
IDENTITY = 60

TEXMTX = [TEXMTX0,TEXMTX1,TEXMTX2,TEXMTX3,TEXMTX4,TEXMTX5,TEXMTX6,TEXMTX7,TEXMTX8,TEXMTX9]

# Post-transform texture matrix index
DTTMTX0 = 64
DTTMTX1 = 67
DTTMTX2 = 70
DTTMTX3 = 73
DTTMTX4 = 76
DTTMTX5 = 79
DTTMTX6 = 82
DTTMTX7 = 85
DTTMTX8 = 88
DTTMTX9 = 91
DTTMTX10 = 94
DTTMTX11 = 97
DTTMTX12 = 100
DTTMTX13 = 103
DTTMTX14 = 106
DTTMTX15 = 109
DTTMTX16 = 112
DTTMTX17 = 115
DTTMTX18 = 118
DTTMTX19 = 121
DTTIDENTITY = 125

# Texture coordinate slot
TEXCOORD0 = 0
TEXCOORD1 = 1
TEXCOORD2 = 2
TEXCOORD3 = 3
TEXCOORD4 = 4
TEXCOORD5 = 5
TEXCOORD6 = 6
TEXCOORD7 = 7
TEXCOORD_NULL = 0xFF

# Texture format
TF_I4 = 0
TF_I8 = 1
TF_IA4 = 2
TF_IA8 = 3
TF_RGB565 = 4
TF_RGB5A3 = 5
TF_RGBA8 = 6
TF_CI4 = 8
TF_CI8 = 9
TF_CI14 = 10
TF_CMPR = 14

# Texture lookup table format
TL_IA8 = 0
TL_RGB565 = 1
TL_RGB5A3 = 2

# Texture coordinate generation type
TG_MTX3x4 = 0
TG_MTX2x4 = 1
TG_BUMP0 = 2
TG_BUMP1 = 3
TG_BUMP2 = 4
TG_BUMP3 = 5
TG_BUMP4 = 6
TG_BUMP5 = 7
TG_BUMP6 = 8
TG_BUMP7 = 9
TG_SRTG = 10

TG_BUMP = [TG_BUMP0,TG_BUMP1,TG_BUMP2,TG_BUMP3,TG_BUMP4,TG_BUMP5,TG_BUMP6,TG_BUMP7]

# Texture coordinate source
TG_POS = 0
TG_NRM = 1
TG_BINRM = 2
TG_TANGENT = 3
TG_TEX0 = 4
TG_TEX1 = 5
TG_TEX2 = 6
TG_TEX3 = 7
TG_TEX4 = 8
TG_TEX5 = 9
TG_TEX6 = 10
TG_TEX7 = 11
TG_TEXCOORD0 = 12
TG_TEXCOORD1 = 13
TG_TEXCOORD2 = 14
TG_TEXCOORD3 = 15
TG_TEXCOORD4 = 16
TG_TEXCOORD5 = 17
TG_TEXCOORD6 = 18
TG_COLOR0 = 19
TG_COLOR1 = 20

TG_TEX = [TG_TEX0,TG_TEX1,TG_TEX2,TG_TEX3,TG_TEX4,TG_TEX5,TG_TEX6,TG_TEX7]
TG_TEXCOORD = [TG_TEXCOORD0,TG_TEXCOORD1,TG_TEXCOORD2,TG_TEXCOORD3,TG_TEXCOORD4,TG_TEXCOORD5,TG_TEXCOORD6]
TG_COLOR = [TG_COLOR0,TG_COLOR1]

# Compare type
NEVER = 0
LESS = 1
EQUAL = 2
LEQUAL = 3
GREATER = 4
NEQUAL = 5
GEQUAL = 6
ALWAYS = 7

# Texture wrap mode
CLAMP = 0
REPEAT = 1
MIRROR = 2

# Blend type
BM_NONE = 0
BM_BLEND = 1
BM_LOGIC = 2
BM_SUBTRACT = 3

# Blend factor
BL_ZERO = 0
BL_ONE = 1
BL_SRCCLR = 2
BL_INVSRCCLR = 3
BL_SRCALPHA = 4
BL_INVSRCALPHA = 5
BL_DSTALPHA = 6
BL_INVDSTALPHA = 7
BL_DSTCLR = BL_SRCCLR
BL_INVDSTCLR = BL_INVSRCCLR

# Logical operation type
LO_CLEAR = 0
LO_AND = 1
LO_REVAND = 2
LO_COPY = 3
LO_INVAND = 4
LO_NOOP = 5
LO_XOR = 6
LO_OR = 7
LO_NOR = 8
LO_EQUIV = 9
LO_INV = 10
LO_REVOR = 11
LO_INVCOPY = 12
LO_INVOR = 13
LO_INVNAND = 14
LO_SET = 15

# TEV color combiner input
CC_CPREV = 0
CC_APREV = 1
CC_C0 = 2
CC_A0 = 3
CC_C1 = 4
CC_A1 = 5
CC_C2 = 6
CC_A2 = 7
CC_TEXC = 8
CC_TEXA = 9
CC_RASC = 10
CC_RASA = 11
CC_ONE = 12
CC_HALF = 13
CC_KONST = 14
CC_ZERO = 15

# TEV alpha combiner input
CA_APREV = 0
CA_A0 = 1
CA_A1 = 2
CA_A2 = 3
CA_TEXA = 4
CA_RASA = 5
CA_KONST = 6
CA_ZERO = 7

# TEV stage
TEVSTAGE0 = 0
TEVSTAGE1 = 1
TEVSTAGE2 = 2
TEVSTAGE3 = 3
TEVSTAGE4 = 4
TEVSTAGE5 = 5
TEVSTAGE6 = 6
TEVSTAGE7 = 7
TEVSTAGE8 = 8
TEVSTAGE9 = 9
TEVSTAGE10 = 10
TEVSTAGE11 = 11
TEVSTAGE12 = 12
TEVSTAGE13 = 13
TEVSTAGE14 = 14
TEVSTAGE15 = 15

# TEV combiner operator
TEV_ADD = 0
TEV_SUB = 1
TEV_COMP_R8_GT = 8
TEV_COMP_R8_EQ = 9
TEV_COMP_GR16_GT = 10
TEV_COMP_GR16_EQ = 11
TEV_COMP_BGR24_GT = 12
TEV_COMP_BGR24_EQ = 13
TEV_COMP_RGB8_GT = 14
TEV_COMP_RGB8_EQ = 15
TEV_COMP_A8_GT = TEV_COMP_RGB8_GT
TEV_COMP_A8_EQ = TEV_COMP_RGB8_EQ

# TEV bias value
TB_ZERO = 0
TB_ADDHALF = 1
TB_SUBHALF = 2

# TEV scale value
CS_SCALE_1 = 0
CS_SCALE_2 = 1
CS_SCALE_4 = 2
CS_DIVIDE_2 = 3

# TEV color/output register
TEVPREV = 0
TEVREG0 = 1
TEVREG1 = 2
TEVREG2 = 3

# Cull mode
CULL_NONE = 0
CULL_FRONT = 1
CULL_BACK = 2
CULL_ALL = 3

# Texture map slot
TEXMAP0 = 0
TEXMAP1 = 1
TEXMAP2 = 2
TEXMAP3 = 3
TEXMAP4 = 4
TEXMAP5 = 5
TEXMAP6 = 6
TEXMAP7 = 7
TEXMAP_NULL = 0xFF
TEXMAP_DISABLE = 0x100

# Alpha combine control
AOP_AND = 0
AOP_OR = 1
AOP_XOR = 2
AOP_XNOR = 3

# TEV constant color register
KCOLOR0 = 0
KCOLOR1 = 1
KCOLOR2 = 2
KCOLOR3 = 3

# TEV constant color selection
TEV_KCSEL_1 = 0
TEV_KCSEL_7_8 = 1
TEV_KCSEL_3_4 = 2
TEV_KCSEL_5_8 = 3
TEV_KCSEL_1_2 = 4
TEV_KCSEL_3_8 = 5
TEV_KCSEL_1_4 = 6
TEV_KCSEL_1_8 = 7
TEV_KCSEL_K0 = 12
TEV_KCSEL_K1 = 13
TEV_KCSEL_K2 = 14
TEV_KCSEL_K3 = 15
TEV_KCSEL_K0_R = 16
TEV_KCSEL_K1_R = 17
TEV_KCSEL_K2_R = 18
TEV_KCSEL_K3_R = 19
TEV_KCSEL_K0_G = 20
TEV_KCSEL_K1_G = 21
TEV_KCSEL_K2_G = 22
TEV_KCSEL_K3_G = 23
TEV_KCSEL_K0_B = 24
TEV_KCSEL_K1_B = 25
TEV_KCSEL_K2_B = 26
TEV_KCSEL_K3_B = 27
TEV_KCSEL_K0_A = 28
TEV_KCSEL_K1_A = 29
TEV_KCSEL_K2_A = 30
TEV_KCSEL_K3_A = 31

# TEV constant alpha selection
TEV_KASEL_1 = 0
TEV_KASEL_7_8 = 1
TEV_KASEL_3_4 = 2
TEV_KASEL_5_8 = 3
TEV_KASEL_1_2 = 4
TEV_KASEL_3_8 = 5
TEV_KASEL_1_4 = 6
TEV_KASEL_1_8 = 7
TEV_KASEL_K0_R = 16
TEV_KASEL_K1_R = 17
TEV_KASEL_K2_R = 18
TEV_KASEL_K3_R = 19
TEV_KASEL_K0_G = 20
TEV_KASEL_K1_G = 21
TEV_KASEL_K2_G = 22
TEV_KASEL_K3_G = 23
TEV_KASEL_K0_B = 24
TEV_KASEL_K1_B = 25
TEV_KASEL_K2_B = 26
TEV_KASEL_K3_B = 27
TEV_KASEL_K0_A = 28
TEV_KASEL_K1_A = 29
TEV_KASEL_K2_A = 30
TEV_KASEL_K3_A = 31

# TEV color swap table entry
TEV_SWAP0 = 0
TEV_SWAP1 = 1
TEV_SWAP2 = 2
TEV_SWAP3 = 3

# TEV color channel
CH_RED = 0
CH_GREEN = 1
CH_BLUE = 2
CH_ALPHA = 3

# Indirect texture stage
INDTEXSTAGE0 = 0
INDTEXSTAGE1 = 1
INDTEXSTAGE2 = 2
INDTEXSTAGE3 = 3

# Indirect texture format
ITF_8 = 0
ITF_5 = 1
ITF_4 = 2
ITF_3 = 3

# Indirect texture bias select
ITB_NONE = 0
ITB_S = 1
ITB_T = 2
ITB_ST = 3
ITB_U = 4
ITB_SU = 5
ITB_TU = 6
ITB_STU = 7

# Indirect texture matrix
ITM_OFF = 0
ITM_0 = 1
ITM_1 = 2
ITM_2 = 3
ITM_S0 = 5
ITM_S1 = 6
ITM_S2 = 7
ITM_T0 = 9
ITM_T1 = 10
ITM_T2 = 11

ITM = [ITM_0,ITM_1,ITM_2]
ITM_S = [ITM_S0,ITM_S1,ITM_S2]
ITM_T = [ITM_T0,ITM_T1,ITM_T2]

# Indirect texture wrap value
ITW_OFF = 0
ITW_256 = 1
ITW_128 = 2
ITW_64 = 3
ITW_32 = 4
ITW_16 = 5
ITW_0 = 6

# Indirect texture bump alpha select
ITBA_OFF = 0
ITBA_S = 1
ITBA_T = 2
ITBA_U = 3

# Indirect texture scale
ITS_1 = 0
ITS_2 = 1
ITS_4 = 2
ITS_8 = 4
ITS_16 = 5
ITS_64 = 6
ITS_128 = 7
ITS_256 = 8

# Fog equation control
FOG_NONE = 0
FOG_PERSP_LIN = 2
FOG_PERSP_EXP = 4
FOG_PERSP_EXP2 = 5
FOG_PERSP_REVEXP = 6
FOG_PERSP_REVEXP2 = 7
FOG_ORTHO_LIN = 10
FOG_ORTHO_EXP = 12
FOG_ORTHO_EXP2 = 13
FOG_ORTHO_REVEXP = 14
FOG_ORTHO_REVEXP2 = 15
FOG_LIN = FOG_PERSP_LIN
FOG_EXP = FOG_PERSP_EXP
FOG_EXP2 = FOG_PERSP_EXP2
FOG_REVEXP = FOG_PERSP_REVEXP
FOG_REVEXP2 = FOG_PERSP_REVEXP2

# Texture filter types
NEAR = 0
LINEAR = 1
NEAR_MIP_NEAR = 2
LIN_MIP_NEAR = 3
NEAR_MIP_LIN = 4
LIN_MIP_LIN = 5

# Maximum anisotropy filter control
ANISO_1 = 0
ANISO_2 = 1
ANISO_3 = 2

#______________________________________________________________________________
