from btypes import *

#------------------------------------------------------------------------------

class Header(Struct):
    magic = ByteString(4)
    section_size = uint32
    entry_count = uint16
    __padding__ = Padding(2)
    count_offset = uint32
    joint_index_offset = uint32
    weight_offset = uint32
    matrix_offset = uint32 # (inverse) bind-pose matrices?

    def __init__(self):
        self.magic = b'EVP1'

#------------------------------------------------------------------------------

def pack(stream):
    # Just write an empty section
    header = Header()
    header.section_size = 32
    header.entry_count = 0
    header.count_offset = 0
    header.joint_index_offset = 0
    header.weight_offset = 0
    header.matrix_offset = 0
    Header.pack(stream,header)
    align(stream,0x20)

#______________________________________________________________________________
